clark_west <- function(actual, forecast_1, forecast_2) {
  
  e_1 <- actual - forecast_1
  e_2 <- actual - forecast_2
  
  r2_os <- 100 * (1 - mean(e_2 ^ 2) / mean(e_1 ^ 2)) 
  
  f_hat <- e_1 ^ 2 - (e_2 ^ 2 - (forecast_1 - forecast_2) ^ 2)
  
  y_i <- f_hat
  x_i <- matrix(1, nrow = nrow(f_hat), ncol = 1)
  
  beta_i <- solve(t(x_i) %*% x_i) * (t(x_i) %*% y_i)
  e_i <- y_i - x_i %*% beta_i
  sig2_e <- (t(e_i) %*% e_i) / (nrow(y_i) - 1)
  cov_beta_i <- sig2_e %*% solve(t(x_i) %*% x_i)
  
  msfe_adj <- beta_i / sqrt(cov_beta_i)
  p_value <- 1 - pnorm(msfe_adj, 0, 1)
  
  msfe_2 <- mean((e_2 * 100) ^ 2)
  
  output <- list(msfe_2, r2_os, msfe_adj[1], p_value[1])
  names(output) <- c("msfe", 'r2os', 'msfe-adj', 'p-value')
  
  return(output)
  
}